# HOW TO USE:
# 1. Run "/scoreboard players set min forming <minimum number>" to set a minimum number
# 2. Run "/scoreboard players set max forming <maximum number>" to set a maximum number
# 3. Run "/function <your_pack_name>:forming" to generate the number
# 4. Your ranom number between the given minimum and maximum is now stored as "out" in "forming"
# (Get it with "/scoreboard players operation <PLAYER> <SCOREBOARD> = out forming")
#
# *You don't need to set the minimum and maximum every time, it'll use the last used
# or the base which is min 0, max 100


# Activate the pack
execute unless entity @e[tag=formingactive] run scoreboard objectives add forming dummy
execute unless entity @e[tag=formingactive] run scoreboard players set min forming 0
execute unless entity @e[tag=formingactive] run scoreboard players set max forming 61
execute unless entity @e[tag=formingactive] run summon area_effect_cloud ~ ~ ~ {Tags:["formingbase"],Duration:1}
execute unless entity @e[tag=formingactive] run execute store result score num forming run data get entity @e[type=area_effect_cloud,limit=1,tag=formingbase] UUID[0]
execute unless entity @e[tag=formingactive] run scoreboard players set a forming 48141429
execute unless entity @e[tag=formingactive] run scoreboard players set b forming 4819982
execute unless entity @e[tag=formingactive] run scoreboard players set m forming 924866
execute unless entity @e[tag=formingactive] run execute at @p run summon minecraft:marker ~ ~ ~ {Tags:["formingactive"]}

# Prepare to use a minimum different from 0
scoreboard players operation trueMax forming = max forming
scoreboard players operation trueMax forming -= min forming
scoreboard players add trueMax forming 1

# Modify output
scoreboard players operation num forming *= a forming
scoreboard players operation num forming += b forming
scoreboard players operation out forming = num forming
scoreboard players operation out forming %= m forming
scoreboard players operation out forming %= trueMax forming
scoreboard players operation out forming += min forming

# Uncomment (remove the "# ") next line to print output
# tellraw @a {"score":{"name":"out","objective":"forming"}}

# This module was made by Natural_Power
# You may use it any way you want as long as these stay inside the module
execute if score stormspawnrate gamerules matches 1 run schedule function atmospheric:weather/forming 1s
execute if score stormspawnrate gamerules matches 2 run schedule function atmospheric:weather/forming 2s
execute if score stormspawnrate gamerules matches 3 run schedule function atmospheric:weather/forming 3s
execute if score stormspawnrate gamerules matches 4 run schedule function atmospheric:weather/forming 4s
execute if score stormspawnrate gamerules matches 5 run schedule function atmospheric:weather/forming 5s
execute if score stormspawnrate gamerules matches 6 run schedule function atmospheric:weather/forming 6s
execute if score stormspawnrate gamerules matches 7 run schedule function atmospheric:weather/forming 7s
execute if score stormspawnrate gamerules matches 8 run schedule function atmospheric:weather/forming 8s
execute if score stormspawnrate gamerules matches 9 run schedule function atmospheric:weather/forming 9s
execute if score stormspawnrate gamerules matches 10 run schedule function atmospheric:weather/forming 10s
execute if score stormspawnrate gamerules matches 11 run schedule function atmospheric:weather/forming 11s
execute if score stormspawnrate gamerules matches 12 run schedule function atmospheric:weather/forming 12s
execute if score stormspawnrate gamerules matches 13 run schedule function atmospheric:weather/forming 13s
execute if score stormspawnrate gamerules matches 14 run schedule function atmospheric:weather/forming 14s
execute if score stormspawnrate gamerules matches 15 run schedule function atmospheric:weather/forming 15s
#rain
execute as @r at @s if score out forming matches 1..2 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #atmospheric:spring if score press weather matches ..-10 positioned ^ ^ ^15 run function atmospheric:weather/spawning/rain
#hail
execute as @r at @s if score out forming matches 3..4 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #atmospheric:tornado_formable if score press weather matches ..-10 positioned ^-25 ^ ^25 run function atmospheric:weather/spawning/hail
#wind
execute as @r at @s if score out forming matches 5..6 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #atmospheric:tornado_formable if score press weather matches ..-20 if score wind weather matches 10.. positioned ^ ^ ^25 run function atmospheric:weather/spawning/wind
#lightning
execute as @r at @s if score out forming matches 7..8 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #atmospheric:summer if score press weather matches ..-30 positioned ^ ^ ^30 run function atmospheric:weather/spawning/lightning
#tornado
execute as @r at @s if score out forming matches 9..10 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #atmospheric:tornado_formable if score press weather matches ..-25 if score wind weather matches 15.. positioned ^-30 ^ ^30 run function atmospheric:weather/spawning/twister
#hurricane
execute as @r at @s if score out forming matches 11..12 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #atmospheric:hurricane_formable if score press weather matches ..-80 positioned ^ ^ ^50 run function atmospheric:weather/spawning/cyclone
#snow
execute as @r at @s if score out forming matches 13..14 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #atmospheric:snowstorms_formable if score press weather matches ..-10 positioned ^ ^ ^15 run function atmospheric:weather/spawning/snow
#blizzard
execute as @r at @s if score out forming matches 15..16 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #atmospheric:snowstorms_formable if score press weather matches ..-10 positioned ^ ^ ^15 run function atmospheric:weather/spawning/blizzard
#sandstorm
execute as @r at @s if score out forming matches 17..18 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ minecraft:desert if score wind weather matches 10.. positioned ^ ^ ^15 run function atmospheric:weather/spawning/sand
#dust devil
execute as @r at @s if score out forming matches 31..32 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ minecraft:desert if score wind weather matches 5.. positioned ^ ^ ^15 run function atmospheric:weather/spawning/dd
#fog
execute as @r at @s if score out forming matches 19..20 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #minecraft:is_taiga if score wind weather matches 15.. positioned ^ ^ ^15 run function atmospheric:weather/spawning/fog
#acid rain
execute as @r at @s if score out forming matches 21..22 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #minecraft:is_nether if score press weather matches ..-10 positioned ^ ^ ^25 run function atmospheric:weather/spawning/acidrain
#firenado
execute as @r at @s if score out forming matches 23..24 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #minecraft:is_nether if score press weather matches ..-20 positioned ^-25 ^ ^ run function atmospheric:weather/spawning/fire
#emberstorm
execute as @r at @s if score out forming matches 25..26 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #minecraft:is_nether if score press weather matches 20.. positioned ^-25 ^ ^ run function atmospheric:weather/spawning/ember
#endstorm
execute as @r at @s if score out forming matches 27..28 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #is_end positioned ^-15 ^ ^ run function atmospheric:weather/spawning/end
#ErRoR
execute as @r at @s if score out forming matches 29..30 unless entity @e[tag=weather,distance=0..75] if biome ~ ~ ~ #atmospheric:error positioned ^-15 ^ ^ run function atmospheric:storm/create/voidnado
#else
execute if score out forming matches 35 run scoreboard players add press weather 30
execute if score out forming matches 41 run scoreboard players add press weather 20
execute if score out forming matches 45 run scoreboard players add press weather 10
execute if score out forming matches 50 run scoreboard players remove press weather 10
execute if score out forming matches 56 run scoreboard players remove press weather 20
execute if score out forming matches 60 run scoreboard players remove press weather 30
#Seasonal
execute as @r[tag=spring] at @s if score out forming matches 18 run summon breeze ~3 ~5 ~3 {DeathLootTable:"atmospheric:entitys/spring_breeze",attributes:[{id:"generic.scale",base:2d},{id:"generic.attack_speed",base:75f},{id:"generic.flying_speed",base:1f},{id:"generic.follow_range",base:500f},{id:"generic.movement_speed",base:1f},{id:"generic.max_health",base:1f}],CustomName:'[{"text":"Spring Breeze","color":"yellow"}]',Tags:["springbreeze"]}