# stuff
execute as @e[tag=morningstarsapling] run data merge entity @s {NoGravity:1b}
execute as @e[tag=morningstarsapling] run data remove entity @s IsBaby
item replace entity @e[tag=morningstarsapling] weapon.mainhand with air
item replace entity @e[name="Siren"] weapon.mainhand with air
item replace entity @e[name="Weather Radar"] weapon.mainhand with air
item replace entity @e[name="Weather Deflector"] weapon.mainhand with air
# Morningstar Log
execute as @e[name="Morningstar Log"] at @s run place template atmospheric:block/morningstarlog ~ ~ ~
execute as @e[name="Morningstar Log"] at @s run kill @s
execute as @e[type=minecraft:item_display,tag=morningstarlog,tag=!placed] at @s run function atmospheric:blocks/morningstar_log/place
execute as @e[type=minecraft:item_display,tag=morningstarlog,tag=placed] at @s unless block ~ ~ ~ minecraft:glass run function atmospheric:blocks/morningstar_log/remove
execute as @a at @s if entity @e[type=minecraft:item_display,tag=morningstarlog,tag=placed,distance=0..7] run advancement grant @s only minecraft:husbandry/find_new_tree
# Morningstar Planks
execute as @e[name="Morningstar Planks"] at @s run place template atmospheric:block/morningstarplanks ~ ~ ~
execute as @e[name="Morningstar Planks"] at @s run kill @s
execute as @e[type=minecraft:item_display,tag=morningstarplanks,tag=!placed] at @s run function atmospheric:blocks/morningstar_planks/place
execute as @e[type=minecraft:item_display,tag=morningstarplanks,tag=placed] at @s unless block ~ ~ ~ minecraft:brown_stained_glass run function atmospheric:blocks/morningstar_planks/remove
# Morningstar Saplings
effect give @e[tag=morningstarsapling] invisibility infinite 127 true
execute as @e[tag=morningstarsapling] run execute store result score @s Health run data get entity @s Health
execute as @e[tag=morningstarsapling] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:bone_meal"}},distance=0..1] run place template atmospheric:tree/morningstar ~-2 ~ ~-2
execute as @e[tag=morningstarsapling] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:bone_meal"}},distance=0..1] run particle happy_villager ~ ~ ~ 2 2 2 0.001 20 normal
execute as @e[tag=morningstarsapling] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:bone_meal"}},distance=0..1] run kill @e[type=item,nbt={Item:{id:"minecraft:bone_meal"}},distance=0..1]
execute as @e[tag=morningstarsapling] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:bone_meal"}},distance=0..1] run tp @s ~ ~1000000 ~
execute as @e[tag=morningstarsapling] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:bone_meal"}},distance=0..1] run kill @s
execute as @e[tag=morningstarsapling] at @s run execute if score @s Health matches 0..10 run summon item ~ ~2 ~ {Item:{id:"breeze_spawn_egg",Count:1b,components:{"minecraft:custom_model_data":2,"minecraft:entity_data":{id:husk,Health:11,DeathLootTable:"atmospheric:blocks/morningstarsapling",NoAI:1b,PersistenceRequired:1b,Silent:1b,Rotation:[140f],ActiveEffects:[{Id:14,Duration:999999999,Amplifier:255,ShowParticles:0b}],Tags:["morningstarsapling"],ArmorItems:[{},{},{},{id:breeze_spawn_egg,components:{"minecraft:custom_model_data":2},Count:1}],attributes:[{id:"generic.max_health",base:11f}],ArmorDropChances:[0f,0f,0f,0f]},"minecraft:custom_name":'[{"text":"Morningstar Sapling","italic":false}]'}}}
execute as @e[tag=morningstarsapling] at @s run execute if score @s Health matches 0..10 run kill @s
execute as @a at @s if entity @e[tag=morningstarsapling,distance=0..5] run advancement grant @s only minecraft:husbandry/plant_tree
#Corn Stalk
execute as @e[name="Corn Stalk"] at @s run place template atmospheric:crops/corn ~ ~1 ~
execute as @e[name="Corn Stalk"] at @s run kill @s
execute as @e[tag=cornstalk] at @s unless entity @e[tag=corninteraction,distance=0..0.5] run kill @s
execute as @e[tag=corninteraction] at @s unless block ~ ~-0.5 ~ farmland run kill @s
execute as @e[tag=cornstalk,tag=growth1] run data merge entity @s {item:{components:{"minecraft:custom_model_data":20}, count:1, id: "enderman_spawn_egg"}}
execute as @e[tag=cornstalk,tag=growth2] run data merge entity @s {item:{components:{"minecraft:custom_model_data":21}, count:1, id: "enderman_spawn_egg"}}
execute as @e[tag=cornstalk,tag=growth3] run data merge entity @s {item:{components:{"minecraft:custom_model_data":22}, count:1, id: "enderman_spawn_egg"}}
execute as @e[tag=cornstalk,tag=growth4] run data merge entity @s {item:{components:{"minecraft:custom_model_data":23}, count:1, id: "enderman_spawn_egg"}}
execute as @e[tag=corninteraction,tag=growth3int] run function atmospheric:weather/abilities/cornstalk3int_1
execute as @e[tag=corninteraction,tag=growth2int] run function atmospheric:weather/abilities/cornstalk2int_1
execute as @e[tag=corninteraction,tag=growth1int] run function atmospheric:weather/abilities/cornstalk1int_1
execute as @e[tag=corninteraction,tag=!growth4int] at @s on target if entity @s[nbt={SelectedItem:{id:"minecraft:bone_meal"}}] run execute at @e[tag=corninteraction,tag=!growth4int,distance=0..0.5] run particle happy_villager ~ ~ ~ 2 2 2 0.001 20 normal
execute as @e[tag=corninteraction] run data remove entity @s interaction
execute as @e[tag=corninteraction] at @s on attacker run execute at @e[tag=corninteraction,distance=0..0.5] run summon item ~ ~1 ~ {Item:{id:"enderman_spawn_egg",Count:1b,components:{"minecraft:custom_model_data":24,"minecraft:entity_data":{id:marker,CustomName:'[{"text":"Corn Stalk"}]',DeathLootTable:"atmospheric:blocks/morningstarsapling",Health:12,NoAI:1,PersistenceRequired:1b,Silent:1b,Rotation:[140f],Tags:["growth1"],ArmorItems:[{},{},{},{id:enderman_spawn_egg,Count:1}],ArmorDropChances:[0f,0f,0f,0f],active_effects:[{id:invisibility,duration:2,amplifier:2,show_particles:0b}],attributes:[{id:"generic.max_health",base:12f}]},"minecraft:custom_name":'[{"text":"Corn Seed","italic":false}]'}}}
execute as @e[tag=corninteraction,tag=growth4int] run function atmospheric:weather/abilities/cornstalk4int_2
execute as @e[tag=corninteraction,tag=growth1int] at @s on attacker run execute at @e[tag=corninteraction,tag=growth1int,distance=0..0.5] run particle block{block_state: {Name: "minecraft:wheat", Properties: {age: "4"}}} ~ ~ ~ 0.5 0.5 0.5 0.001 10 normal
execute as @e[tag=corninteraction,tag=growth2int] at @s on attacker run execute at @e[tag=corninteraction,tag=growth2int,distance=0..0.5] run particle block{block_state:"minecraft:bamboo"} ~ ~ ~ 0.5 1 0.5 0.001 10 normal
execute as @e[tag=corninteraction,tag=growth3int] at @s on attacker run execute at @e[tag=corninteraction,tag=growth3int,distance=0..0.5] run particle block{block_state:"minecraft:bamboo"} ~ ~ ~ 0.5 1.5 0.5 0.001 10 normal
execute as @e[tag=corninteraction,tag=growth4int] at @s on attacker run execute at @e[tag=corninteraction,tag=growth4int,distance=0..0.5] run particle item{item: {id: "green_dye"}} ~ ~ ~ 0.5 2 0.5 0.001 5 normal
execute as @e[tag=corninteraction,tag=growth4int] at @s on attacker run execute at @e[tag=corninteraction,tag=growth4int,distance=0..0.5] run particle item{item: {id: "yellow_dye"}} ~ ~ ~ 0.5 2 0.5 0.001 5 normal
execute as @e[tag=corninteraction] at @s on attacker run kill @e[distance=0..0.5,tag=cornstalk]
execute as @e[tag=corninteraction] at @s on attacker run kill @e[distance=0..0.5,tag=corninteraction]
execute as @a at @s if entity @e[tag=growth1,distance=0..5] run advancement grant @s only minecraft:husbandry/plant_seed
execute as @a at @s if entity @e[tag=growth1,distance=0..5] run advancement grant @s only minecraft:husbandry/cornseed
execute as @a at @s if entity @e[tag=growth4,distance=0..5] run advancement grant @s only minecraft:husbandry/cornfound
execute as @a[nbt={SelectedItem:{id:"minecraft:golden_apple",components:{"minecraft:custom_model_data":1}}}] run advancement grant @s only minecraft:husbandry/corn
execute as @a[nbt={SelectedItem:{id:"minecraft:bone_meal",components:{"minecraft:custom_model_data":1}}}] run advancement grant @s only minecraft:husbandry/deadcorn
execute as @e[tag=corninteraction] at @s if block ~ ~-0.5 ~ farmland[moisture=0] run setblock ~ ~-1 ~ farmland[moisture=0] replace